VRay::Context.active.then { |context|
  context.scene.grep(:CosmosAsset) { |asset|
    next unless asset[:resolve_types].empty?
    VRay::Galaxy::connection.then { |connection|
      connection.get_package(package_id: asset[:package_id], revision: asset[:revision])&.then { |package|
        connection.resolve_package_paths(package)&.then { |result| 
          context.scene.change {
            asset[:resolve_types] = result[:resolve_types]
          }
        }
      }
    }
  }
}